;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: bsdm.clp
;;
;; BSDM utility functions. Use in conjunction with 
;; repall.clp
;;
;; in fact this functionalities can be replaced
;; by "show all card info", given in tool: kbst-bm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defglobal ?*total-bsdm-entity* = -1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Count how many bsdm entities are in the model. 
;;
;;     (count-bsdm-entity)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction count-bsdm-entity ()

   (message-box "Note: Please represent the model." OK)

   (rep-all-models)
   (assert (count-bsdm-entity start))
   (run)

   (return 1)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; rule 1
(defrule count-bsdm-entity-1
   (count-bsdm-entity start)
   (not (all-bsdm-entity $?))
   ?d <- (bsdm_card ?card entity ?name ?obj)
=> 
   (retract ?d) 
   (assert (all-bsdm-entity ?name))
) ;; defrule

;; rule 2
(defrule count-bsdm-entity-2
   (count-bsdm-entity start)
   ?d1 <- (bsdm_card ?card entity ?name ?obj)
   ?d2 <- (all-bsdm-entity $?list)
   (not   (all-bsdm-entity $? ?name  $?))
=> 
   (retract ?d1 ?d2)
   (printout t ?name crlf )
   (assert (all-bsdm-entity $?list ?name))
) ;; defrule


(defrule count-bsdm-entity-3
   (declare  (salience -10000))
   (all-bsdm-entity $?list)
   (count-bsdm-entity start)
=>
   (bind ?*total-bsdm-entity* (length$ $?list ))
   (bind ?msg (str-cat "There are in total " 
               ?*total-bsdm-entity* " entities."))
   (message-box ?msg OK)

) ;; defrule 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; end of file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
