;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: c-seek.clp
;;
;; Given a node name, find all of the node with that
;; name on.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   (load "./system/c-seek.clp") 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defglobal ?*search-card-type* = "")
(defglobal ?*search-node-type* = "")
(defglobal ?*search-node-name* = "")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction on-close (?frame)
   (window-delete ?frame)  
   (return 1)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Top Function (0.2.1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction carry-out-node-search ()
   
  (message-box "Under Construction." OK)

) ;; deffunction 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; inconsistency window menu function and 
;; search menu  (0.2)
;; 
;; called by chk-racd.clp
;; called by c-seek.clp 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction simple-menu (?frame ?id)

 ;;;;;;;; execute ;;;;;;;;; not used, designed for
 ;; chk-racd.clp 
 (if (eq ?id 1) then
     (printout t "choose menu 1: Modify" crlf)
     (return 1)
 ) ;;if 

 ;;;;;;;; search for a node
 (if (eq ?id 2) then
     (printout t "choose menu 2 - search" crlf)
     (carry-out-node-search)
     ;; (display-search-result)
 ) ;;if 

 ;;;;;; cancel frame ;;;;;;
 (if (eq ?id 9) then
        (window-delete ?frame)  
        (return 1)
 ) ; end-id-2

 (return 0)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; text-item call-back functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; search card type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction search-card-type (?text-id)
 (printout t "search-card-type " ?text-id crlf)
 (bind ?*search-card-type* 
       (text-get-value ?text-id))
);; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; search node type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction search-node-type (?text-id)
 (printout t "search-node-type " ?text-id crlf)
 (bind ?*search-node-type* 
      (text-get-value ?text-id))
);; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; search node name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction search-node-name (?text-id)
 (printout t "search-node-name " ?text-id crlf)
 (bind ?*search-node-name* 
      (text-get-value ?text-id))
);; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; display-search-node-window (0.1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction display-search-node-window 
         (?card-type ?node-type ?node-name)

 (printout t "---- display-search-node-window  ----" crlf)
 
  ;;;;; copy all search information 
  (bind ?*search-card-type* ?card-type)
  (bind ?*search-node-type* ?node-type)
  (bind ?*search-node-name* ?node-name)

  ;;;;;;;;;;;;;;;;;;; Create Frame ;;;;;;;;;;;;;;;;;;;;;;;
  (bind ?frame (frame-create 0 "Inconsistency Report" -1 -1 300 300))
  (window-add-callback ?frame OnClose on-close)
  (window-add-callback ?frame OnMenuCommand simple-menu)

  ;;;;;;;;;;;; Menu & Manu bars ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  ;;;;; create a menu ;;;;;;;
  (bind ?search-menu (menu-create))
  ;; add menu item, id = 2
  (menu-append ?search-menu 2 "&Search")

  ;;;;; create a menu ;;;;;;
  (bind ?exit-menu (menu-create))
  ;; add item id=9 
  (menu-append ?exit-menu 9 "&Cancel")

  ;;;;;;;;;;;;;;; Create Menu Bar ;;;;;;;;;;;;;
  (bind ?menu-bar (menu-bar-create))

  ;;; add Menues to this Menu Bar
  (menu-bar-append ?menu-bar ?search-menu "&Search")
  (menu-bar-append ?menu-bar ?exit-menu "&Cancel")

  ;;; add the menu-bar to the frame !!
  (frame-set-menu-bar ?frame ?menu-bar)
   
  ;;;;;;;;;; Create a panel on frame ;;;;;;;;;
  (bind ?panel (panel-create ?frame 0 0 280 250))
  (panel-set-label-position ?panel wxVERTICAL)

  ;;; create text item 
  (message-create ?panel "Card Type: ")
  (bind ?panel-value (text-create 
        ?panel "search-card-type" "" ?card-type -1 -1 300 50))
  (panel-new-line ?panel)

  (message-create ?panel "Node Type: ")
  (bind ?panel-value (text-create 
        ?panel "search-node-type" "" ?node-type -1 -1 300 50))
  (panel-new-line ?panel)

  (message-create ?panel "Node Name: ")
  (panel-new-line ?panel)
  (bind ?panel-value (multi-text-create 
        ?panel "search-node-name" "" ?node-name -1 -1 500 70))
  (panel-new-line ?panel)

  ;;;;;;;; fit the content to window ;;;;;;;;;
  (window-fit ?panel)
  (window-fit ?frame)

  ;;;;; show window ;;;;;
  (window-show ?frame 1)

  ;;;;;;;; assert frame information ?? ;;;;;

  (return 1)
) ;; deffun 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TOP Function for Search-node (0)
;;   (search-node-top)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(deffunction search-node-top ()

  ;;; get card and node information 
  (bind ?card       ?*select-card*)
  (bind ?image      ?*select-image*)
  (bind ?obj        ?*select-obj*)
  (bind ?node-name  ?*select-node-name*)

  ;; (1) selected a node 
  (if (and (> ?card  0)
           (> ?obj 0))  then 
      (bind ?card-type (my-card-get-type2 ?card))
      (bind ?node-type (diagram-object-get-string-attribute
                  ?card ?obj type))
      (display-search-node-window 
            ?card-type ?node-type ?node-name)  )

  ;; (2) not selected a node
  (if (or  (< ?card  0)
           (< ?obj 0))  then 
      (bind ?card-type (my-card-get-type2 ?card))
      (bind ?node-type (diagram-object-get-string-attribute
                  ?card ?obj type))
      (display-search-node-window  "*" "*" "*") )

  (return 1)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; end of file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;