;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  File: comm.clp 
;;
;; Author: Jessica Chen-Burger
;; contains common Functions. 
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;     (load "./system/comm.clp") 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; called by metabsdm.clp, metauml1.clp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction instantiate-field 
   (?from-card ?from-obj ?to-card ?to-obj
    ?from-field ?to-field)

   (bind ?value (diagram-object-get-string-attribute 
         ?from-card ?from-obj ?from-field))

   (if (neq ?value "") then 
       (diagram-object-set-string-attribute 
         ?to-card ?to-obj ?to-field ?value) )

   (return 1)
);; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; copy all non-empty fields 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction  copy-all-field
   (?from-card ?from-obj ?to-card ?to-obj)

   (bind ?att (diagram-object-get-first-attribute 
               ?from-card ?from-obj)) 

   (while (neq ?att "")

     (bind ?value (diagram-object-get-string-attribute 
           ?from-card ?from-obj ?att))

     (if (and (neq ?att type) 
              (neq ?att "type") 
              (neq ?att "id") 
              (neq ?att "card") 
              (neq ?att "images") 
              (neq ?att "arcs") 
              (neq ?value "") ) 
      then 
         (diagram-object-set-string-attribute 
          ?to-card ?to-obj ?att ?value)  ) ;; if

     (bind ?att (diagram-object-get-next-attribute))
   ) ;; while

   (return 1)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; overwrite all fields (empty or not) !! 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction  overwrite-all-field
   (?from-card ?from-obj ?to-card ?to-obj)
  
   ;; (printout t "---- overwrite-all-field ----" crlf)

   (bind ?att (diagram-object-get-first-attribute 
               ?from-card ?from-obj)) 

   (while (neq ?att "")

     (bind ?value (diagram-object-get-string-attribute 
           ?from-card ?from-obj ?att))

     (if (and (neq ?att type) 
              (neq ?att "type") 
              (neq ?att "id") 
              (neq ?att "card") 
              (neq ?att "images") 
              (neq ?att "arcs") ) then

         (diagram-object-set-string-attribute 
          ?to-card ?to-obj ?att ?value) );; if

     (bind ?att (diagram-object-get-next-attribute))
   ) ;; while

   (return 1)
) ;; deffun 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;             end of file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

