;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; File: edify-t.clp
; 
; Dealing with Edify card, transform an "activity" node to 
; a "system call" node. 
;
; calling comm.clp 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction transform-to-system-call (?from-card ?from-image)

  (printout t "Calling transform-to-system-call....." crlf)

  ;; get card type
  (bind ?card-type (my-card-get-type2 ?from-card))
 
  (if (neq ?card-type "Edify") then
      (message-box "Abort: function only valid on an Edify diagram." OK)
      (return -1)
  );;if

  ;;;;;;;;;;;; get node details ;;;;;;;;;;;;;;;
  (bind ?from-obj  (diagram-image-get-object ?from-card ?from-image))
  (bind ?from-type (diagram-object-get-string-attribute 
                                          ?from-card ?from-obj type))

  ;;;;;;;; error checking 
  
  (bind ?ans "YES")
  (if (neq ?from-type "Activity") then
      (bind ?ans (message-box "Error: function only valid on an Activity node.
Do you want to continue? " YES-NO))

  );;if

  (if (eq ?ans NO) then (return -1))

  ;;;;;;;;;;;;;;; create a new node ;;;;;;;;;;;;
  (bind ?to-image (node-image-create ?from-card "System Call"))
  (bind ?to-obj (diagram-image-get-object ?from-card ?to-image))
  (diagram-image-move ?from-card ?to-image 50 50)

  ;;;;;;;; copy all of the attribute values ;;;;;;;;;
  (copy-all-field ?from-card ?from-obj ?from-card ?to-obj)

  ;;;;; to show the newly created System Call node ;;;;;;;
  (my-show-node-name ?from-card ?to-obj) 
  
  (return 1) 
);; deffun 