;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Edify.clp 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; rep activity nodes on one card 

(deffunction  rep-edify-card   (?card ?write-file) 

  ;; get image id
  (bind ?image (diagram-card-get-first-node-image ?card))

  (while (> ?image 0)

   ;; get node details
   (bind ?obj  (diagram-image-get-object ?card ?image))
   (bind ?type (diagram-object-get-string-attribute ?card ?obj type))
   (bind ?name (diagram-object-get-string-attribute ?card ?obj "Name"))
   (bind ?hp (diagram-object-get-string-attribute ?card ?obj
              "Hierarchical Position"))
   (bind ?id (diagram-object-get-string-attribute ?card ?obj "ID"))

    ;; rep an activity node 
    (if (eq ?type "Activity")  then 
        (assert (act-node ?name ?hp ?id)) 
        (printout ?write-file "(act-node ")
        (printout ?write-file "\"" ?name "\"  " )
        (printout ?write-file "\ " ?hp " " ?id ")" crlf)                      
    ) ;; if

    ;; get next image id
    (bind ?image (diagram-card-get-next-node-image))
  ) ;; while

  (return 1)  ) ;;deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; rep all Edify cards 

(deffunction rep-all-edify-cards ()

  (bind ?ans (message-box 
        "Do you want to represent all Edify cards?"  YES-NO))
  (if (neq ?ans YES) then 
      (return -1) )
  (unwatch all) ;; to speed up the program 
  (reset)       ;; reset working memory

  ;;;; open a write file
  (bind ?write-file "edify.out")
  (close)
  (open "edify.out" ?write-file "w") ;; write new data
  (printout ?write-file "%%%%% Edify Activity Nodes %%%%%" crlf)
  (printout ?write-file "%%%%% Jessica Chen-Burger  %%%%%" crlf crlf)

  ;; get card id
  (bind ?card (hardy-get-first-card))
  (while (> ?card 0)
      
  ;; get card type
  (bind ?card-type (my-card-get-type2 ?card))
 
      ;; (1) represent an Edify Card 
      (if (eq ?card-type "Edify") then 
          (card-show ?card)
          (rep-edify-card ?card ?write-file) );; if 

    ;; next card 
      (card-quit ?card) 
      (bind ?card (hardy-get-next-card))
  );; while

  (close) ;; close open file 
  (message-box "Edify Activies have been exported to file:edify.out." OK)
  (return 1)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
