;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  File: IDEF3.CLP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defglobal ?*idef0-act-name*  = -1)
(defglobal ?*idef0-act-label* = -1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(deffunction get-idef0-name (?label)

   (assert (temp idef0-act-label ?label))
   (run)
   (return ?*idef0-act-label*)

);; deffun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defrule     get-uob-name 
   ?d <-  (temp idef0-act-label ?label)
   (idef0 "Label" ?name ?label)
=> 
   (bind ?*idef0-act-name* ?name)
   (retract ?d) )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; To automatically create an idef3 card and to auto
;; instantiated its attributes.  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(deffunction create-idef3-card (?parent-card)

  (bind ?card (diagram-card-create ?parent-card "My-IDEF3"))
  
  (bind ?ans (message-box 
   "Would you like to create activity nodes?" YES-NO))

  (if (eq ?ans NO) then (return 1))

  (bind ?ans (get-text-from-user "Enter IDEF0 Labels (1,2,3):"))
  (bind ?first (my-first ?ans))
  (bind ?rest  (my-rest  ?ans))
     
  (while (neq ?first "")
          
      ;; create node image ;;
      (bind ?image (node-image-create ?card "UOB"))
      (diagram-image-move ?card ?image 50 50)

      ;; to instantiate UOB name 

      (bind ?obj (diagram-image-get-object ?card ?image))
      (bind ?name (get-idef0-name ?first))

      (diagram-object-set-string-attribute ?card ?obj "Name" ?name)
      (diagram-object-set-string-attribute ?card ?obj "Label" ?first)

      ;; to show UOB name 
      (diagram-object-format-text ?card ?obj) 
      (diagram-card-clear-canvas ?card)
      (diagram-card-redraw ?card)

      ;; next UOB
      (bind ?first (my-first ?rest))
      (bind ?rest  (my-rest  ?rest))
  )
      
  (return 1)

) ;; deffun 
