;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: left-all.clp 
;;
;; by Jessica Chen-Burger 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;     (load ./system/left-all.clp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; global variables used here, copied to global.clp 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;(defglobal ?*select-card*  = -1)
;;(defglobal ?*select-card-type*  = -1)
;;(defglobal ?*select-image*  = -1)
;;(defglobal ?*select-obj*  = -1)
;;(defglobal ?*select-obj-type*  = -1)
;;(defglobal ?*select-node-name*  = -1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Main Function 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction all-left-click (?card ?image ?x ?y ?shift ?control)

  ;; not useful for me, not used. 
  ;; (diagram-card-copy ?card)

  ;; (printout t "--- calling all-left-click ---" crlf)

  (bind ?object    (get-object-from-image ?card ?image))
  (bind ?name      (diagram-object-get-string-attribute ?card ?object
                    "Name")) 
  (bind ?card-type (my-card-get-type2 ?card))
  (bind ?obj-type  (diagram-object-get-string-attribute
                    ?card ?object type))

  (bind ?*select-card*        ?card)
  (bind ?*select-card-type*   ?card-type)
  (bind ?*select-image*       ?image)
  (bind ?*select-obj*         ?object)
  (bind ?*select-obj-type*    ?obj-type)
  (bind ?*select-node-name*   ?name)

  (printout t "Selected node: "?name "=>" ?card "=>" ?image crlf) 

  ;;;;;;;;;;;; Broadcast/consistency check info ;;;;;;;;;;;
  ;; get more info

  (bind ?menu-title (str-cat "Attribute Menu For 
" ?name))

  (bind ?choice -1)
  (if (and (eq ?control 1)(eq ?card-type "RACD")
           (or (eq ?obj-type  "Role") (eq ?obj-type "Activity")
               (eq ?obj-type  "Collective Activity")
               (eq ?obj-type  "Data") (eq ?obj-type "Data Store"))
      )
   then
      (bind ?choice (get-choice ?menu-title
                    (mv-append  "Show Node Attributes"
                                "Represent RACD Nodes"
                                "Check Attribute Values"
                                "Broadcast Attribute Values"
                    )))
  );; if 

  ;;;;;; show node attributes ;;;;;

  (if (eq ?choice "Show Node Attributes") then 
      (return 1)
  ) ;; 

  ;;;;;; Represent RACd Nodes ;;;;;;;;;;
  (if (eq ?choice "Represent RACD Nodes") then 
      (rep-racd-top)
      (return 0)    ) ;; 

  ;;;;;; check the consistency of att values ;;;;;;
  (if (eq ?choice "Check Attribute Values") then 
      (check-racd-att-consistency ?obj-type ?name)
      (return 0)    ) ;; 

  ;;;;;; broadcast attributes to all other nodes ;;;;;;;
  (if (eq ?choice "Broadcast Attribute Values") then 
      (broadcast-racd-atts ?card ?image ?obj-type ?name)
      (return 0)    ) ;; if 

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  (return 1)  );; end-deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of File 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
