;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: meta.clp 
;;
;; Author: Jessica Chen-Burger
;; 
;; From Meta-Model to Meta-Model
;; This files handles most of meta-model operations 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Use the below global variables
; (defglobal ?*select-card*  = -1)
; (defglobal ?*select-image*  = -1)
; (defglobal ?*select-obj*  = -1)
; (defglobal ?*select-node-name*  = -1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; copy contents from a concrete class to an abstract class
;; or vice versa

(deffunction copy-meta-class (?card ?option)

   (if (eq ?*select-card* -1) then 
       (message-box "Please select a node." OK)
       (return -1)  )

   (bind ?card-type (card-get-string-attribute ?card diagram-type))

   (if (neq ?card-type "Meta-Model") then 
       (return -1) )

   ;; create concrete class 
   (if (eq ?option "concrete") then 
       (bind ?image (node-image-create ?card "Concrete Class"))
       (bind ?obj (diagram-image-get-object ?card ?image)) )

   ;; create abstract class 
   (if (eq ?option "abstract") then 
       (bind ?image (node-image-create ?card "Abstract Class"))
       (bind ?obj (diagram-image-get-object ?card ?image)) )

   ;; copy the abstract class to concrete class
   (copy-all-field ?card ?*select-obj* ?card ?obj)

   ;; show image
   (diagram-image-move ?card ?image 50 50)
   (my-show-node-name  ?card ?obj) 

) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
