;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: objcon.clp 
;;
;; Author: Jessica Chen-Burger
;; function: maintain one object consistency within one
;;           modelling language
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   (load "./system/objcon.clp")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Use the below global variables to rep selected node: 
; 
; (defglobal ?*select-card*  = -1)
; (defglobal ?*select-card-type*  = -1)
; (defglobal ?*select-image*  = -1)
; (defglobal ?*select-obj*  = -1)
; (defglobal ?*select-obj-type*  = -1)
; (defglobal ?*select-node-name*  = -1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; main function
;;
;; invoked by custom-menu, on any diagram card
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;       
(deffunction  global-change-object-name (?card)
  
   (printout t "-- global-change-object-name --" crlf) 
   (if (or (neq ?card ?*select-card*) 
           (<   ?*select-image* 0) )
    then 
       (message-box "Please re-select the node." OK)
       (return -1)  )
             
   (bind  ?old-name ?*select-node-name*)
   (printout t ?old-name crlf) 

   ;; calling dialog.clp 
   (my-dialog-box-create ?*select-card-type* 
           ?*select-obj-type*  ?old-name)

   (return 1)
);; deffunction 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
;; end of file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            