
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: repuml1.clp 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Sub-1
;; 
;; represent just one card of UML class model 
;; rep the classes, and all of the relationships between
;; them 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(deffunction represent-uml1-card (?card)

  (card-show ?card)

  ;;;;;;;;;;;;;;;; (1) rep all nodes ;;;;;;;;;;;;;;;;;;
  (bind ?image (diagram-card-get-first-node-image ?card))

  (while (neq ?image -1) 

    ;; get node details
    (bind ?obj  (diagram-image-get-object ?card ?image))    
    (bind ?name (diagram-object-get-string-attribute ?card ?obj "Name"))
    (bind ?type (diagram-object-get-string-attribute ?card ?obj type))

    ;; rep a node 
        (assert (uml-class-model node ?type ?name ?card ?image))

    ;; get next node id
    (bind ?image (diagram-card-get-next-node-image))
  );; while 

  ;;;;;;;;;;;;;;;;; (2) rep all links ;;;;;;;;;;;;;;;;;;;;
  
  (bind ?arc (diagram-card-get-first-arc-image ?card))
  (while (> ?arc 0)

    (bind ?obj (diagram-image-get-object ?card ?arc))    
    (bind ?type (diagram-object-get-string-attribute ?card ?obj type))

    ;; rep an arc
      (bind ?from-image  (get-arc-image-from          ?card ?arc))
      (bind ?from-object (get-object-from-image       ?card ?from-image))
      (bind ?from-name   (get-object-string-attribute ?card ?from-object "Name"))
      (bind ?from-type   (get-object-string-attribute ?card ?from-object type))

      (bind ?to-image  (get-arc-image-from            ?card ?arc))
      (bind ?to-object (get-object-from-image         ?card ?to-image))
      (bind ?to-name   (get-object-string-attribute   ?card ?to-object "Name"))
      (bind ?to-type   (get-object-string-attribute   ?card ?to-object type))

    (assert (uml-class-model relationship ?type ?card ?arc ?from-name ?to-name))

  (bind ?arc (diagram-card-get-next-arc-image))
  ) ;; while 

  ;;;;;;;;;;;;;;;;;;;;;;
  (card-quit ?card)
  (return 1)

) ;; deffun 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Top Function
;;
;; Representing the UML class model (uml1); i.e. represent
;; all of the UML-Class Cards.
;;
;;    (rep-uml-class-model)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(deffunction rep-uml-class-model ()

  (bind ?ans (message-box 
        "Do you want to represent the UML Class Model?"  YES-NO))
  (if (neq ?ans YES) then 
      (return -1) )

  (unwatch all) ;; to speed up the program 
  (reset)       ;; reset working memory

;; get card id
  (bind ?card (hardy-get-first-card))
  (while (neq ?card -1)

      ;; get card type
      (bind ?card-type (my-card-get-type2 ?card))
 
      ;; represent a UML-Class-Model card
      (if (eq ?card-type "UML Class Diagram") then 
          (represent-uml1-card ?card)  )

      ;; next card 
      (bind ?card (hardy-get-next-card))
  );; while

  (message-box "Finished Representing UML Class Model." OK)
  (return 1)

) ;; end of function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; End of file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;