
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(deffunction fill-node-with-value-1 (?card) 

  (dialog-box-create 0 "Please specify node type.")

  ;;; get all images ;;; 
  (bind ?image (diagram-card-get-first-node-image ?card))
  (while (neq ?image -1) 

    ;; get node details
    (bind ?obj  (diagram-image-get-object ?card ?image))
    (bind ?type (diagram-object-get-string-attribute ?card ?obj type))
    (bind ?name (diagram-object-get-string-attribute ?card ?obj "Name"))

    ;; only rep the following nodes, and will be used by this file 
    ;; and quick.clp 
    (if (or (eq ?type "Activity") 
            (eq ?type "Role") 
            (eq ?type "Data") 
            (eq ?type "Data Store") 
            (eq ?type "Collective Activity") 
        )  then 

        (assert (racd_card ?card node_info ?type ?name ?image ?obj))
        (rep-racd-atts ?card ?obj ?type ?name)

        ;; store node name - used by quick.clp 
        (if (eq (member$ ?name ?*all-racd-node-names*) FALSE) then 
                (bind ?*all-racd-node-names* 
                (create$ ?*all-racd-node-names* ?name)) );; if
    );; if 

    ;; get next node id
    (bind ?image (diagram-card-get-next-node-image))
  );; while

  (return 1)
) ;; deffun 
;;;;;;;;;;;;;;;;;;;