%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% File: template.clp 
%%
%% By Jessica Chen-Burger
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Cards Functions

(hardy-get-top-card)
(bind ?card (hardy-get-first-card))
(bind ?card (hardy-get-next-card))

(bind ?card-title (card-get-string-attribute ?card title))     

(bind ?card-type (card-get-string-attribute ?card diagram-type))
 
OR, even better
(bind ?card-type (my-card-get-type2 ?card))

(bind ?file (card-get-string-attribute ?card print-file))
(diagram-card-save-file ?card ?file)

(card-show    ?card)
(card-iconize ?card)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% get attributes

 (bind ?att (diagram-object-get-first-attribute 
         ?card ?obj)) 

 (bind ?att (diagram-object-get-next-attribute))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


(bind ?win(dialog-box-create ?parent-id "title"))
(window-show ?win 1 )

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% a simple way to get user input !! 

(bind ?ans (get-text-from-user "Please enter text:"))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% create three different kinds of cards

(card-create ?parent-id "card_type")

(diagram-card-create ?parent-id "diagram_type")

(diagram-card-create-expansion ?parent-id ?image_id)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  ;;;; de-select this node !! 
  (bind ?*selected-node* (create$))

  (diagram-image-select ?card ?image 0)
  (diagram-card-clear-canvas ?card)
  (diagram-card-redraw ?card)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% window functions

(text-create ?panel "" ?title ?content-value -1 -1 370))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% image functions 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% copy a node image

(bind ?image (node-image-duplicate ?card ?object))
(diagram-image-move ?card ?image 200 300)


;;; can only duplicate on the same diagram card 
 (bind ?image (node-image-duplicate 137054 137167)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(bind ?from  (get-arc-image-from ?card ?image))
(bind ?to    (get-arc-image-to   ?card ?image))

(bind ?from (diagram-image-get-object ?card ?from))
(bind ?to   (diagram-image-get-object ?card ?to))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% get all images

(bind ?image (diagram-card-get-first-node-image ?card))
(bind ?image (diagram-card-get-next-node-image))

(bind ?obj (diagram-image-get-object ?card ?image))

%% get arc information

(bind ?image (diagram-card-get-first-arc-image ?card))
(bind ?image (diagram-card-get-next-arc-image))


(bind ?type 
  (diagram-object-get-string-attribute ?card ?obj "type"))

(diagram-object-set-string-attribute ?card ?obj "Name" ?name)

;; to show entity name
(diagram-object-format-text ?card ?obj) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% create nodes

(bind ?image (node-image-create ?card "entity"))
(diagram-image-move ?card ?image 50 50 )

;; to show entity name
(bind ?obj (diagram-image-get-object ?card ?image))
(diagram-object-format-text ?card ?obj) 

(diagram-card-clear-canvas ?card)
(diagram-card-redraw ?card)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% image processing

(node-image-create ?card "relationship")

(diagram-image-move ?card ?image-id 40 100)
(diagram-card-clear-canvas ?card) 
(diagram-card-redraw ?card)  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 (bind ?arc (diagram-card-get-girst-arc-image))
  (while (> ?arc 0)

   ;;;;; content        

  (bind ?ard (diagram-card-get-next-arcImage))
  ) ;; while 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% create arc images - partial-participation

(bind ?arc (arc-image-create ?card 
      "partial-participation" ?node-1 ?node-2))

(diagram-image-move ?card ?image-id 40 170)
(diagram-card-clear-canvas ?card)
(diagram-card-redraw ?card) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% create arc images - total-participation

(arc-image-create ?card "total-participation"
                  ?node-3 ?node-2)
?arc-id-2

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% create an image, give it a name, and resize it

%% get information from an arc

   (bind ?x-pos  (diagram-image-get-x	   ?card ?image))
   (bind ?y-pos  (diagram-image-get-y	   ?card ?image))
   (bind ?width  (diagram-image-get-width  ?card ?image))
   (bind ?height (diagram-image-get-height ?card ?image))

   ;; area of y
      (bind ?h1 (- ?y (/ ?h 2)))
      (bind ?h2 (+ ?y (/ ?h 2)))

   (bind ?image  (node-image-create ?new-card "entity"))
   (bind ?obj (diagram-image-get-object ?new-card  ?image))
   (diagram-object-set-string-attribute ?new-card ?obj "Name"
         ?node-name)

   (diagram-image-move   ?new-card ?image ?x-pos ?y-pos) 
   (diagram-image-resize ?new-card ?image ?width ?height)
   (diagram-card-clear-canvas ?new-card)
   (diagram-card-redraw ?new-card) 
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Testing string manipulation of clips 6.0

(assert (temp))

(defrule temp
   ?d1 <- (temp $?x)
  =>
   (retract ?d1) 
   (bind ?ll (length $?x))
   (assert (length-temp ll))
   (bind $?y (mv-delete 2 $?x))
   (assert (new-temp $?y))  )

(str-explode 
    (str-implode (mv-append "this is" "just a" "test"))  )

(deffunction temp ()
 (bind ?e1 (nth 1
  (mv-append 
    (str-implode (mv-append "this is" "just a" "test"))
    (str-implode (mv-append " this is another " " test")) )  ))
 (printout t ?e1)
 (bind ?e1 (str-explode ?e1))
)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
< clips 6.0 >

CREATE$: Appends its arguments together to create a multifield value.
(create$ <expression>*)

NTH$: Returns the specified field of a multifield value.
(nth$ <integer-expression> <multifield-expression>)

MEMBER$: Returns the position of a single-field value within a
multifield 
value.
(member$ <single-field-expression> <multifield-expression>)

SUBSETP: Returns TRUE if the first argument is a subset of the second 
argument.
(subsetp <multifield-expression> <multifield-expression>)

DELETE$: Deletes the specified range from a multifield value.
(delete$ <multifield-expression>
         <begin-integer-expression> <end-integer-expression>)
PRESS <RETURN> FOR MORE. PRESS <A>,<RETURN> TO ABORT.

EXPLODE$: Creates a multifield value from a string.
(explode$ <string-expression>)

IMPLODE$: Creates a string from a multifield value.
(implode$ <multifield-expression>)

SUBSEQ$: Extracts the specified range from a multifield value.
(subseq$ <multifield-expression> 
         <begin-integer-expression> <end-integer-expression>)

REPLACE$: Replaces the specified range of a multifield value with a 
          set of values.
(replace$ <multifield-expression>
          <begin-integer-expression> <end-integer-expression> 
          <single-or-multifield-expression>+)

INSERT$: Inserts one or more values in a multifield.
(insert$ <multifield-expression> <integer-expression> 
         <single-or-multifield-expression>+)
FIRST$: Returns the first field of a multifield.
(first$ <multifield-expression>)
PRESS <RETURN> FOR MORE. PRESS <A>,<RETURN> TO ABORT.

REST$: Returns all but the first field of a multifield.
(rest$ <multifield-expression>)

LENGTH$: Returns the number of fields in a multifield value.
(length$ <multifield-expression>)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

STR-CAT: Concatenates its arguments to form a single string.
(str-cat <expression>*)

SYM-CAT: Concatenates its arguments to form a single symbol.
(sym-cat <expression>*)

SUB-STRING: Retrieves a subportion from a string.
(sub-string <integer-expression> <integer-expression>
<string-expression>)

STR-INDEX: Returns the position of the first argument within the second 
           argument.
(str-index <lexeme-expression> <lexeme-expression>)

EVAL: Evaluates a string as though it were entered at the command
prompt.
      Only allows functions to be evaluated.
(eval <lexeme-expression>)

BUILD: Evaluates a string as though it were entered at the command
prompt.
       Only allows constructs to be evaluated.
(build <lexeme-expression>)

UPCASE: Converts lowercase characters in a string or symbol to
uppercase.
(upcase <lexeme-expression>)

LOWCASE: Converts uppercase characters in a string or symbol to
lowercase.
(lowcase <lexeme-expression>)

STR-COMPARE: Lexigraphically compares two strings.
(str-compare <lexeme-expression> <lexeme-expression>)

STR-LENGTH: Returns the length of a string.
(str-length <lexeme-expression>)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
