;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; File: uml1-1.clp
;;
;; Create a separate uml class diagram for viewing
;; one-class-centered VIEW 
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defrule instantiate-uml-view-nodes 

  (instantiate-uml-view-nodes ?card ?par-name))
  (
  (uml-class-model node ?node-type 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Main Function 
;;
;;  invoked by custom-menu
;;  function: after the selected uml class has been
;;  "left-clicked" this function can be invoked
;;  from custom menu
;;  
;;  purpose: to create a new uml-class diagram
;;  which displays all of the relevant classes which
;;  are related to the selected class. 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(deffunction create-one-class-centered-view ()

  ;; get the selected uml class info
  
  (bind ?par-card      ?*select-card*)
  (bind ?par-card-type ?*select-card-type*)
  (bind ?par-image     ?*select-image*)
  (bind ?par-object    ?*select-obj*)
  (bind ?par-obj-type  ?*select-obj-type*)
  (bind ?par-name      ?*select-node-name*)

  (if (or (<   ?par-card 0)
          (neq ?par-card-type "UML Class Diagram")
          (neq ?par-obj-type  "Class")  )
   then 

      (message-box "Error: please select a UML Class." OK)
      (return -1)   );; if 

  ;; create a card and give card title
  
  (bind ?card (diagram-card-create ?par-card "UML Class Diagram"))
  (bind ?title (str-cat "One Class Center View: "
                        ?par-name))
  (card-set-string-attribute ?card title ?title)
   
  ;; create the center-class itself

  


  ;; instantiate the card with nodes, and 
  ;; instantiate the card with links

  (assert (instantiate-uml-view-nodes ?card ?par-name))

  (run)

  ;; refresh and re-display the card 

  ;;;;;;;;;;;;;;;;;
  (return -1)
) ;; deffun 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; end of file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
